<template>
  <div class="pa-10">
    <p v-if="circles === null" class="infos-label">Loading...</p>
    <v-row v-if="!circles || circles.length === 0">
      <v-col class="text-center">
        <p class="body-1">You don't have any circles yet</p>
        <v-btn color="primary" to="/facilitator/new-circle"
          >Add new Circle</v-btn
        >
      </v-col>
    </v-row>
    <v-row v-if="circles && circles.length > 0">
      <v-col class="text-right">
        <v-btn color="primary" to="/facilitator/new-circle"
          >Add new Circle</v-btn
        >
      </v-col>
    </v-row>
    <v-row>
      <v-col
        v-for="(circle, i) in circles"
        :key="i"
        xs="12"
        sm="6"
        md="4"
        lg="3"
      >
        <v-card class="mx-auto">
          <v-img
            class="white--text align-end"
            height="150px"
            :src="
              circle.imageUrl
                ? circle.imageUrl
                : 'https://cdn.vuetifyjs.com/images/cards/docks.jpg'
            "
          >
          </v-img>
          <v-card-text class="text--primary pb-0">
            <div class="text-center font-weight-bold">
              <h3>{{ circle.title }}</h3>
            </div>
          </v-card-text>
          <v-card-text class="text--primary ">
            <div class="">
              {{ circle.users.length }} Members of
              {{ circle.numOfParticipants }}
            </div>
            <div>
              Type: <b>{{ circle.circleType }}</b>
            </div>
            <div>
              Duration:
              <b
                >{{ circle.sessionDuration.hr }} hrs and
                {{ circle.sessionDuration.min }} minutes</b
              >
            </div>
            <div class="">
              <b> ${{ circle.price }} </b>/Session
            </div>
          </v-card-text>

          <v-card-actions>
            <v-btn
              color="primary"
              text
              :to="'/facilitator/groups/' + circle.id"
            >
              <v-icon>fas fa-user-friends</v-icon>
            </v-btn>
            <v-btn
              color="primary"
              text
              :to="`/facilitator/circle/${circle.id}`"
            >
              <v-icon>fas fa-pencil-alt</v-icon>
            </v-btn>
            <v-menu offset-y>
              <template v-slot:activator="{ on, attrs }">
                <v-btn color="primary" text v-bind="attrs" v-on="on">
                  <v-icon>mdi-chevron-down</v-icon>
                </v-btn>
              </template>
              <v-list dense>
                <v-list-item>
                  <v-list-item-icon>
                    <v-icon>mdi-content-duplicate</v-icon>
                  </v-list-item-icon>
                  <v-list-item-content>
                    <v-list-item-title>Duplicate</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
                <v-list-item>
                  <v-list-item-icon>
                    <v-icon>mdi-archive</v-icon>
                  </v-list-item-icon>
                  <v-list-item-content>
                    <v-list-item-title>Archive</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
                <v-divider />
                <v-list-item @click="deleteCircle(circle)">
                  <v-list-item-icon>
                    <v-icon color="primary">mdi-delete-empty-outline</v-icon>
                  </v-list-item-icon>
                  <v-list-item-content>
                    <v-list-item-title color="primary"
                      >Delete</v-list-item-title
                    >
                  </v-list-item-content>
                </v-list-item>
              </v-list>
            </v-menu>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'FacilitatorDashboard',
  components: {},
  data: () => ({}),
  head() {
    return {
      title: {
        inner: 'Facilitator Dashboard'
      }
    }
  },
  computed: {
    ...mapState('circle', ['circles'])
  },
  watch: {},
  methods: {
    editCircle(circle) {
      this.$router.push(`/facilitator/circle/${circle.id}`)
    },
    deleteCircle(circle) {
      this.$store.commit('circle/addDeleteCircleId', circle.id)
      this.$store.dispatch('circle/deleteCircle', circle.id, {root: true}).then(res => {
        if(res.data.status && res.data.data){
          this.$store.commit('circle/deleteFromCircles', circle.id)
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.v-card {
  border-radius: 12px !important;
}
</style>
